VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form FProcMgr 
   Caption         =   "Visual Basic Process Manager"
   ClientHeight    =   6270
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6735
   Icon            =   "FProcMgr.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6270
   ScaleWidth      =   6735
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Left            =   5760
      Top             =   120
   End
   Begin VB.Frame Frame1 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   5115
      Left            =   240
      TabIndex        =   1
      Top             =   480
      Width           =   5115
      Begin VB.CommandButton Command1 
         Caption         =   "&End Process"
         Height          =   375
         Index           =   0
         Left            =   3420
         TabIndex        =   2
         Top             =   4560
         Width           =   1515
      End
      Begin ComctlLib.ListView ListView1 
         Height          =   4215
         Left            =   120
         TabIndex        =   3
         Top             =   180
         Width           =   4875
         _ExtentX        =   8599
         _ExtentY        =   7435
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         _Version        =   327682
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   1
         NumItems        =   0
      End
   End
   Begin ComctlLib.TabStrip TabStrip1 
      Height          =   5655
      Left            =   120
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   120
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   9975
      _Version        =   327682
      BeginProperty Tabs {0713E432-850A-101B-AFC0-4210102A8DA7} 
         NumTabs         =   1
         BeginProperty Tab1 {0713F341-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "Processes"
            Key             =   ""
            Object.Tag             =   ""
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "FProcMgr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Member vars
Private procs As CProcesses

' Control indices
Private Const cEndTask = 0

' Subitem fields
Private Const iHandle = 1
Private Const iMemUsage = 2
Private Const iMemDelta = 3

' ************************************************************
'  Event procedures
' ************************************************************
Private Sub Command1_Click(Index As Integer)
   Dim ProcessID As Long
   
   Select Case Index
      Case cEndTask
         ' Retrieve hWnd for selected item
         If Not ListView1.SelectedItem Is Nothing Then
            ProcessID = CLng(ListView1.SelectedItem.SubItems(iHandle))
            procs.Item(ID:=ProcessID).Terminate
         End If
         
         
   End Select
End Sub

Private Sub Form_Activate()
   ' Set initial column widths
   With ListView1
      .ColumnHeaders(1).Width = 1500
      .ColumnHeaders(2).Width = 600
   End With
   ' Fill listview
   Call RefreshProcList
   ' Start without any task selected,
   ' and switch/end buttons disabled.
   Set ListView1.SelectedItem = Nothing
   Call ResetButtons(False)
End Sub

Private Sub Form_Load()
   Dim clm As ColumnHeader
   ' Setup listview
   With ListView1
      .View = lvwReport
      Set clm = .ColumnHeaders.Add(, , "Image Name")
      clm.Alignment = lvwColumnLeft
      Set clm = .ColumnHeaders.Add(, , "PID", .Width / 5)
      clm.Alignment = lvwColumnRight
      Set clm = .ColumnHeaders.Add(, , "Mem Usage", .Width / 5)
      clm.Alignment = lvwColumnRight
      Set clm = .ColumnHeaders.Add(, , "Mem Delta", .Width / 5)
      clm.Alignment = lvwColumnRight
      .SortOrder = lvwAscending
      .Sorted = True
      .HideSelection = False
   End With
   ' Setup processes class
   Set procs = New CProcesses
   ' Sync colors
   Frame1.BackColor = Me.BackColor
   ' Setup timer
   Timer1.Interval = 2000
   Timer1.Enabled = True
   ' Let the world know who we are
   App.Title = Me.Caption
End Sub

Private Sub Form_Resize()
   Dim Margin As Long
   Dim BtnWidth As Long
   
   ' Cache a few common values
   Margin = ListView1.Left
   BtnWidth = Command1(cEndTask).Width
   
   On Error Resume Next
   With TabStrip1
      ' Position tabstrip on form and frame within tab
      .Move .Left, .Left, Me.ScaleWidth - .Left * 2, Me.ScaleHeight - .Left * 2
      Frame1.Move .ClientLeft, .ClientTop, .ClientWidth, .ClientHeight
   End With
   With Frame1
      ' Position listview within frame
      ListView1.Move Margin, Margin, .Width - Margin * 2, .Height - Margin * 3 - Command1(cEndTask).Height
      ' Position command buttons
      Command1(cEndTask).Move .Width - BtnWidth - Margin, .Height - Margin - Command1(cEndTask).Height
   End With
End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As ComctlLib.ColumnHeader)
   Select Case ColumnHeader.Index
      Case 1
         ' Toggle sort order
         With ListView1
            If .SortOrder = lvwAscending Then
               .SortOrder = lvwDescending
            Else
               .SortOrder = lvwAscending
            End If
            .Sorted = True
            .Sorted = False
         End With
         
      Case 2
         ' Refresh listview
         Call RefreshProcList
   End Select
End Sub

Private Sub ListView1_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
   Dim itm As ListItem
   ' Select item under mouse, or clear
   ' selection if nothing there.
   With ListView1
      Set itm = .HitTest(x, y)
      If itm Is Nothing Then
         Set .SelectedItem = Nothing
      End If
      Call ResetButtons(Not (.SelectedItem Is Nothing))
   End With
End Sub

Private Sub Timer1_Timer()
   ' Refresh listview
   Call RefreshProcList
End Sub
' ************************************************************
'  Private methods
' ************************************************************
Private Sub RefreshProcList()
   Dim i As Long
   Dim proc As CProcess
   Dim data As String
   Dim prev As Long
   Dim Key As String
   Dim itm As ListItem
   
   ' Refresh process list
   procs.Refresh

   ' Remove processes no longer running
   With ListView1.ListItems
      For i = .Count To 1 Step -1
         If procs.Valid(CLng(.Item(i).SubItems(iHandle))) = False Then
            ' Clear selected item, reset buttons
            If .Item(i).Selected Then
               Set ListView1.SelectedItem = Nothing
               Call ResetButtons(False)
            End If
            .Remove i
         End If
      Next i
   End With

   ' Add processes just started, and update
   ' status for processes already running.
   For i = 1 To procs.Count
      ' Reference this process
      Set proc = procs(i)

      ' Build key and add item to listview, if
      ' not there already. Otherwise, just grab
      ' reference to existing listitem.
      Key = "h" & Hex(proc.ProcessID)
      On Error Resume Next
         Set itm = ListView1.ListItems.Add(, Key, proc.ModuleName)
         If Err.Number Then
            Set itm = ListView1.ListItems(Key)
         End If
      On Error GoTo 0

      ' *********************************************
      '  VB5 Listview will "EnsureVisible" selected
      '  entry if subitems needlessly updated.
      ' *********************************************
      ' Add process ID, if new item.
      data = CStr(proc.ProcessID)
      If itm.Tag <> data Then
         itm.SubItems(iHandle) = data
         itm.Tag = data
      End If

      data = proc.FormatBytes(proc.WorkingSetSize)
      If itm.SubItems(iMemUsage) <> data Then
         prev = GetByteCount(itm.SubItems(iMemUsage))
         itm.SubItems(iMemUsage) = data
         If prev Then
            data = proc.FormatBytes(proc.WorkingSetSize - (prev * 1024))
            If itm.SubItems(iMemDelta) <> data Then
               itm.SubItems(iMemDelta) = data
            End If
         End If
      Else
         ' Memory use didn't change, make sure
         ' that's what it says.
         If itm.SubItems(iMemDelta) <> "0 K" Then
            itm.SubItems(iMemDelta) = "0 K"
         End If
      End If
   Next i
End Sub

Private Function GetByteCount(ByVal data As String) As Long
   Dim n As Long
   data = Trim$(data)
   If Len(data) Then
      n = InStr(data, " ")
      If n Then data = Left$(data, n - 1)
      GetByteCount = CLng(data)
   Else
      GetByteCount = 0
   End If
End Function

Private Sub ResetButtons(ByVal Enabled As Boolean)
   Command1(cEndTask).Enabled = Enabled
End Sub

