VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form FNotResponding 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "End Program"
   ClientHeight    =   3345
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3345
   ScaleWidth      =   5295
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.ProgressBar ProgressBar1 
      Height          =   255
      Left            =   960
      TabIndex        =   5
      Top             =   840
      Visible         =   0   'False
      Width           =   3795
      _ExtentX        =   6694
      _ExtentY        =   450
      _Version        =   327682
      Appearance      =   1
   End
   Begin VB.Timer Timer1 
      Left            =   180
      Top             =   2760
   End
   Begin VB.CommandButton Command1 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Default         =   -1  'True
      Height          =   375
      Index           =   1
      Left            =   4020
      TabIndex        =   0
      Top             =   2760
      Width           =   1035
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&End Now"
      Height          =   375
      Index           =   0
      Left            =   2820
      TabIndex        =   1
      Top             =   2760
      Width           =   1035
   End
   Begin VB.Label Label3 
      Caption         =   "If you choose to end the program immediately, you will lose any unsaved data. To end the program now, click End Now."
      Height          =   855
      Left            =   960
      TabIndex        =   4
      Top             =   1500
      Width           =   4065
   End
   Begin VB.Label Label2 
      Caption         =   "To return to Windows and check the status of the program, click Cancel."
      Height          =   615
      Left            =   960
      TabIndex        =   3
      Top             =   780
      Width           =   3825
   End
   Begin VB.Label Label1 
      Caption         =   "This program is not responding."
      Height          =   435
      Left            =   960
      TabIndex        =   2
      Top             =   240
      Width           =   4245
   End
   Begin VB.Image Image1 
      Height          =   480
      Left            =   180
      Picture         =   "FNotRes.frx":0000
      Top             =   180
      Width           =   480
   End
End
Attribute VB_Name = "FNotResponding"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************************
'  Copyright 2001 Karl E. Peterson
'  All Rights Reserved, http://www.mvps.org/vb
' *************************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code, non-compiled, without prior written consent.
' *************************************************************************
Option Explicit

Public Enum Prompts
   Win32NotResponding
   Win16Waiting
   Win16NotResponding
End Enum

Private m_Caption As String
Private m_hIcon As Long
Private m_Cancelled As Boolean
Private m_Prompt As Prompts
Private m_Wait As Long

Private Const cmdEndNow = 0
Private Const cmdCancel = 1

' ************************************************************
'  Public Properties
' ************************************************************
Public Property Get Cancelled() As Boolean
   Cancelled = m_Cancelled
End Property

Public Property Let Cancelled(ByVal NewVal As Boolean)
   ' Being asked to hide!
   m_Cancelled = NewVal
   Me.Hide
End Property

Public Property Let hIcon(ByVal NewVal As Long)
   m_hIcon = NewVal
End Property

Public Property Let Prompt(ByVal NewVal As Prompts)
   m_Prompt = NewVal
End Property

Public Property Let TaskName(ByVal NewVal As String)
   m_Caption = Trim$(NewVal)
End Property

Public Property Let Wait(ByVal Seconds As Long)
   m_Wait = Seconds
End Property

' ************************************************************
'  Event Procedures
' ************************************************************
Private Sub Command1_Click(Index As Integer)
   m_Cancelled = (Index = cmdCancel)
   Me.Hide
End Sub

Private Sub Form_Initialize()
   ' Set default properties
   m_Wait = 10 'seconds
End Sub

Private Sub Form_Load()
   ' Setup form appearance
   If Len(m_Caption) Then
      Me.Caption = Me.Caption & " - " & m_Caption
   End If
   If m_hIcon Then
      Set Image1.Picture = CreatePicture(m_hIcon, vbPicTypeIcon)
   End If
   Set Me.Icon = Nothing
   Label2.Top = Label2.Top + 30
   Select Case m_Prompt
      Case Win32NotResponding
         Label1.Caption = "This program is not responding."
      Case Win16Waiting
         Label1.Caption = "The system cannot end this program because it is waiting for a response from you."
      Case Win16NotResponding
         Label1.Caption = "Ending Program...Please wait."
         Label2.Visible = False
         ProgressBar1.Visible = True
         ProgressBar1.Min = 0
         ProgressBar1.Max = m_Wait * 2  'Twice as many ticks
         Timer1.Interval = 500   '1/2 second
         Timer1.Enabled = True
   End Select
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
   If UnloadMode = vbFormControlMenu Then
      m_Cancelled = True
   End If
End Sub

Private Sub Timer1_Timer()
   Const errInvalidPropertyValue = 380
   On Error Resume Next
   ProgressBar1.Value = ProgressBar1.Value + 1
   If Err.Number = errInvalidPropertyValue Then
      Timer1.Enabled = False
      Me.Hide
      m_Cancelled = False
   End If
End Sub
